var sServerURL="https://dsservices.aizo.com";

try {
	if (Property.getNode('/config/webservice-api/base-url')!=null) {
		sServerURL=Property.getNode('/config/webservice-api/base-url').getValue();
	}
} catch (e) {
    lWarn.logln('exception accessing base-url');
}


var RemoteConnectivity={	
		makePostCall:function(sFunction, options, sData) {
		    var extraheaders = [];
		    lInfo.logln("making post " + sFunction + ' to ' + sServerURL + ' with data ' + sData);
			try {
			    if (options==null)
                    options= { 'debug' : 0};
                else
                    options.debug=0;
			    var h = new HTTP(options);
			    var code = h.post(sServerURL + sFunction, '', sData);
			    if (code.status.valueOf() === 200) {
			    	lInfo.logln( ': OK [' + code.status + ']');
			    } else {
			    	lInfo.logln(': FAILED! Server replied: "' + code.status + '"');
			    }
		    	lInfo.logln(code.body);
		    	return JSON.parse(code.body);
			} catch (e) {
				lWarn.logln("Error during upload: ");
			    for (var i in e) {
			        lWarn.logln(i + ': ' + e[i]);
			    }
			}
			return 0;
		},
		makeCall:function(sFunction,options) {
		    var extraheaders = [];
		    lInfo.logln("making " + sFunction + ' to ' + sServerURL);
			try {
				if (options==null)
					options= { 'debug' : 0};
				else
					options.debug=0;
			    var h = new HTTP(options);
			    var code = h.get(sServerURL + sFunction, '');
			    if (code.status.valueOf() === 200) {
			    	lInfo.logln( ': OK [' + code.status + ']');
			    } else {
			    	lInfo.logln(': FAILED! Server replied: "' + code.status + '"');
			    }
		    	lInfo.logln(code.body);
		    	return JSON.parse(code.body);
			} catch (e) {
				lWarn.logln("Error during upload: ");
			    for (var i in e) {
			        lWarn.logln(i + ': ' + e[i]);
			    }
			}
			return 0;
		},
		CheckUserByMAC:function() {
			var sMac=this.getMyMac();
			lInfo.logln("CheckUserByMAC");
			return this.makeCall("/internal/accessmanagement/v1_0/Account/CheckUserByMAC?macaddress=" + sMac,{username:'dss@aizo.com',password:'Qeww1343_eWx'});
		},
		CheckExistingTempdSConfiguratorLink : function() {
		    lInfo.logln("CheckExistingTempdSConfiguratorLink");
		    var sParameters =  "token=" + this.getOSPToken() + "&dssid=" + this.getMyDSID() + "&type=Installer";
            return this.makePostCall("/internal/accessmanagement/v1_0/RemoteConnectivity/CheckExistingTempdSConfiguratorLink?" + sParameters, '', '');
		},
		getMyMac: function(){
			return Property.getProperty('/system/host/interfaces/eth0/mac');
		},
		getMyDSID:function(){
			return Property.getProperty('/system/dSID');			
		},
		getMySGTIN:function() {
			return Property.getProperty('/system/dSID');
		},
        enableToken:function(TokenName) {
            var name=Property.getNode('/system/security/applicationTokens/pending/' + TokenName+'/applicationName').getValue();
            Property.setProperty('/system/security/applicationTokens/enabled/' + TokenName + "/token", TokenName);
            Property.setFlag('/system/security/applicationTokens/enabled/' + TokenName + "/token", 'ARCHIVE', true);
            Property.setProperty('/system/security/applicationTokens/enabled/' + TokenName + "/applicationName", name);
            Property.setFlag('/system/security/applicationTokens/enabled/' + TokenName + "/applicationName", 'ARCHIVE', true);
            Property.setProperty('/system/security/applicationTokens/enabled/' + TokenName + "/user", "dssadmin");
            Property.setFlag('/system/security/applicationTokens/enabled/' + TokenName + "/user", 'ARCHIVE', true);         
            Property.setProperty('/system/security/applicationTokens/enabled/' + TokenName + "/source", "remote-connectivity");
            Property.setFlag('/system/security/applicationTokens/enabled/' + TokenName + "/source", 'ARCHIVE', true);           
            Property.getNode('/system/security/applicationTokens/pending').removeChild(TokenName ); 
        },
		getOSPToken:function() {
			Property.load();
			var ospToken=Property.getNode('OSPToken');
			if (ospToken==null) {
                lWarn.logln("OSPToken property not found");
                return '';
			}
			return ospToken.getValue();
		},
		
};